#include <stdio.h>
#include <malloc.h>
#include <fcntl.h>

void SlowSetPalette(char*);
#pragma aux SlowSetPalette  =   \
      "MOV AH,10H"              \
      "MOV Al,12H"              \
      "MOV BX,0"                \
      "MOV CX,0FFH"             \
      "INT 10H"                 \
parm [DX];

void BIOSDisplay(short);
#pragma aux BIOSDisplay = "int 10H" parm [ax];

#define TextMode80x25() BIOSDisplay(3)

void Outb(unsigned short,unsigned char);
#pragma aux Outb = "out dx,al" parm [dx] [al];

void Outw(unsigned short,unsigned short);
#pragma aux Outw = "out dx,ax" parm [dx] [ax];

unsigned char Inb(unsigned short);
#pragma aux Inb = "in al,dx" value [al] parm [dx];

static int OutPrt;
#define AlertRowScan()              { Outb(0x3D4, 8); OutPrt = 0x3D5; }
#define AlertAddressHigh()          { Outb(0x3D4,12); OutPrt = 0x3D5; }
#define AlertAddressLow()           { Outb(0x3D4,13); OutPrt = 0x3D5; }
#define AlertUlineRegister()        { Outb(0x3D4,20); OutPrt = 0x3D5; }
#define AlertModeCntrlRegister()    { Outb(0x3D4,23); OutPrt = 0x3D5; }
#define AlertSplitScreen()          { Outb(0x3D4,24); OutPrt = 0x3D5; }
#define AlertPlaneState()           { Outb(0x3C4, 2); OutPrt = 0x3C5; }
#define AlertMemModeRegister()      { Outb(0x3C4, 4); OutPrt = 0x3C5; }
#define AlertModeRegister()         { Outb(0x3CE, 5); OutPrt = 0x3CF; }
#define AlertMiscRegister()         { Outb(0x3CE, 6); OutPrt = 0x3CF; }
#define AlertHorzPan()              { Outb(0x3C0,19); OutPrt = 0x3C0; }
#define SendData(Value)             Outb(OutPrt,Value)
#define GetData()                   Inb(OutPrt)

#define Plane0  1
#define Plane1  2
#define Plane2  4
#define Plane3  8
#define OpenPlane(x)                Outw(0x3C4, (1 << (8+(x)))+2)

void BlockCopy(char *,char *,int);
#pragma aux BlockCopy = "rep movsd" modify [ecx edi esi] parm [edi] [esi] [ecx];

void BlockStoreB(char *,char,int);
#pragma aux BlockStoreB = "rep stosb" modify [ecx edi] parm [edi] [al] [ecx];

void BlockStoreW(char *,short,int);
#pragma aux BlockStoreW = "rep stosw" modify [ecx edi] parm [edi] [ax] [ecx];

void BlockStoreD(char *,int,int);
#pragma aux BlockStoreD = "rep stosd" modify [ecx edi] parm [edi] [eax] [ecx];

void ClrScrn() {
    AlertPlaneState();
    SendData( 0x0F );
    BlockStoreD( (char *)0x0A0000, 0, 16000 );
}

void LoadXScreen(char * SrcPtr) {
    OpenPlane(0);    BlockCopy((char *)0x0A0000,SrcPtr,4000);
    OpenPlane(1);    BlockCopy((char *)0x0A0000,SrcPtr+16000,4000);
    OpenPlane(2);    BlockCopy((char *)0x0A0000,SrcPtr+32000,4000);
    OpenPlane(3);    BlockCopy((char *)0x0A0000,SrcPtr+48000,4000);
}

void ModeX(void) {

    // Get to Mode 13.
    BIOSDisplay(0x13);

    // Memory division, disable bit 4 of mode register in controller
    AlertModeRegister();
    SendData( GetData() & 0xEF );           // Even mode.

    // Zero bit 1 in miscellaneous register.
    AlertMiscRegister();
    SendData( GetData() & 0xFD );           // Even text mode.

    // MODIFY MEMORY MODE REGISTER IN SEQUENCE CONTROLLER SO NO FURTHER
    // ADDRESS DIVISION FOLLOWS IN BITPLANES.
    AlertMemModeRegister();
    SendData( (GetData() & 0xF7) | 0x4);    // Non-chain, Odd addressing

    // SET DOUBLE WORD MODE USING BIT 6 IN UNDERLINE REGISTER OF CRT
    // CONTROLLER
    AlertUlineRegister();
    SendData( GetData() & 0xBF);            // 0 double word mode.
    AlertModeCntrlRegister();
    SendData( GetData() | 0x60);            // Byte mode, address wrap.
}

void SetStartOffset(int Offset) {
    AlertAddressHigh();
    SendData(Offset >> 8);
    AlertAddressLow();
    SendData(Offset & 0xFF );
}

char PalettePtr[768];
char ScrPtr[65536];
int handle;    // for opening files

#define ReadBinary(Filename,Target,Size) {                          \
   handle = open(Filename, O_RDONLY | O_BINARY);                    \
   read (handle, Target, Size);                                     \
   close(handle);                                                   \
}                                                                   \

void main(){
int i,a;

    ModeX();
    ClrScrn();

    ReadBinary("TITLE.PAL", PalettePtr, 768 );
    SlowSetPalette(PalettePtr);

    GetCh();

    ReadBinary("TITLE.RAW", ScrPtr, 64000 );
    LoadXScreen(ScrPtr);

    GetCh();

    for(i=0; i<3200; i+=80) {
        SetStartOffset(i);
        GetCh();
    }

    TextMode80x25();
}
